import React from "react";

export default (fn) => {
  const [loading, setLoading] = React.useState(false);

  const p = React.useCallback((...args) => {
    return new Promise((resolve, reject) => {
      setLoading(true);
      fn(...args).then((res) => {
        setLoading(false);
        resolve(res);
      }).catch((err) => {
        setLoading(false);
        reject(err)
      })
    })
  }, []);

  return [p, loading];
}
